package index.alg.boxscan;

import com.sun.org.apache.bcel.internal.generic.NEW;
import index.entity.Box;
import index.entity.BoxEdge;
import index.entity.Point;
import java.util.ArrayList;


public class ScanOutLine {

    ArrayList<String> scanPriority;
    Integer numOfGaps;
    ArrayList<ArrayList<BoxEdge>> shapeList = new ArrayList<>();
    ArrayList<ArrayList<Point>> shapePointList = new ArrayList<>();

    //设置扫描的优先级
    public ScanOutLine(ArrayList<String> ScanPriority){

        this.scanPriority = ScanPriority;

    }


    //设置默认的扫描的优先级
    public ScanOutLine(){

        scanPriority.add("UP");
        scanPriority.add("RIGHT");
        scanPriority.add("DOWN");
        scanPriority.add("LEFT");

    }

    //迭代
    public void Scan(ArrayList<Box> allBusyBoxes,Integer numOfGaps) throws Exception{

        this.numOfGaps = numOfGaps;

        //获取所有的不重复的边
        GetAllEdge getAllEdge = new GetAllEdge();
        ArrayList<BoxEdge> boxEdgeArrayList = getAllEdge.cal(allBusyBoxes);

        //随机挑选一个边，然后从边中挑选一个点

        //闭合轮廓list

//        ArrayList<ArrayList<BoxEdge>> shapeList = new ArrayList<>();
//        ArrayList<ArrayList<Point>> shapePointList = new ArrayList<>();

        //挑边
        Integer randomBoxEdgeIndex = (int) (Math.random() * boxEdgeArrayList.size());
        BoxEdge initialBoxEdge = boxEdgeArrayList.get(randomBoxEdgeIndex);

        //挑点，这里挑点1或者点2都可以
        Point pointInitial = initialBoxEdge.getPoint1();

        while (boxEdgeArrayList.size() !=0){

            //某一个连通轮廓
            ArrayList<BoxEdge> shapeSingle = new ArrayList<>();

            //走过的点的list
            ArrayList<Point> shapePoint = new ArrayList<>();

            ArrayList<BoxEdge> matchBoxEdgeArrayList =new ArrayList<>();

            Point pointNext = new Point();

            //按方向去找下一个点
            for (int i = 0; i < scanPriority.size();i++) {

                String direction = scanPriority.get(i);

                Point pointNextTemp = genNextStep(pointInitial, direction);

                if (!isPointLegal(pointNextTemp, this.numOfGaps)) {

                    continue;

                }

                BoxEdge boxEdgeBuild = new BoxEdge();

                //构造边
                boxEdgeBuild.setPoint1(pointInitial);
                boxEdgeBuild.setPoint2(pointNextTemp);

                //寻找和构造的边相等的边
                ArrayList<BoxEdge> matchBoxEdgeArrayListTemp = findEqualBoxEdgeFromList(boxEdgeBuild, boxEdgeArrayList);


                //如果找到了就跳出循环，不再从别的方向上去找下一步的点了
                if (matchBoxEdgeArrayListTemp.size() != 0){

                    matchBoxEdgeArrayList = matchBoxEdgeArrayListTemp;

                    break;
                }

            }
            //四个方向上找了一遍，都没有找到边
                if (matchBoxEdgeArrayList.size() == 0){

                    //这里要分两种情况。
                    //没有找到边，且boxEdgeArrayList的size为0
                    //没有找到边，且boxEdgeArrayList的size不为0
                    shapeList.add(shapeSingle);
                    shapePointList.add(shapePoint);
                    //从剩下的边里产生产生一个初始点
                    Integer randomBoxEdgeIndexNextCircle = (int) (Math.random() * boxEdgeArrayList.size());
                    BoxEdge initialBoxEdgeNextCircle = boxEdgeArrayList.get(randomBoxEdgeIndexNextCircle);

                    //挑点，这里挑点1或者点2都可以
                    pointInitial = initialBoxEdgeNextCircle.getPoint1();


                }

                else if (matchBoxEdgeArrayList.size() > 1){

                    throw new Exception("重复边未完全去除");

                }else {
                    //找到一条边，之后把连接的点存入一个list，并且把查到的那条边也存入一个数组

                    //把走过的点按顺序存入list
                    shapePoint.add(pointInitial);
                    //
                    BoxEdge boxEdgeFind = matchBoxEdgeArrayList.get(0);

                    //把走过的边按顺序存入list
                    shapeSingle.add(boxEdgeFind);

                    //这个需要检查一下看看是不是真的能够remove，如果不行就自己写一个remove方法

                    boxEdgeArrayList = removeBoxEdge(boxEdgeFind,boxEdgeArrayList);

                    pointInitial = pointNext;

                }
        }
    }

    public ArrayList<BoxEdge> removeBoxEdge(BoxEdge boxEdgeForRemove,ArrayList<BoxEdge> boxEdgeArrayList){

        ArrayList<BoxEdge> boxEdgeArrayList1 = new ArrayList<>();
        for (int i = 0 ; i < boxEdgeArrayList.size();i++){

            BoxEdge boxEdge = boxEdgeArrayList.get(i);
            if (!judgeEdgeEqual(boxEdgeForRemove,boxEdge)){

                boxEdgeArrayList1.add(boxEdge);

            }

        }
        return boxEdgeArrayList1;

    }

//    public ArrayList<BoxEdge> findConnectEdge(Point point,ArrayList<BoxEdge> boxEdgeArrayList){
//
//        //所有与该点相连的边，一般一个，有可能没有。
//        ArrayList<BoxEdge> boxEdgesConnected = new ArrayList<>();
//
//        //
//
//        for (int i = 0 ; i < boxEdgeArrayList.size();i++){
//
//
//            BoxEdge boxEdge = boxEdgeArrayList.get(i);
//            Point point1 = boxEdge.getPoint1();
//            Point point2 = boxEdge.getPoint2();
//            boolean isEqualToP1 = judgePointEqual(point,point1);
//            boolean isEqualToP2 = judgePointEqual(point,point2);
//
//            if ( isEqualToP1 || isEqualToP2 ){
//
//                boxEdgesConnected.add(boxEdge);
//
//            }
//
//
//
//        }
//
//
//    }

    public boolean judgePointEqual(Point point1,Point point2){

        boolean isEqual = false;

        if ((point1.getColX().equals(point2.getColX())) && (point1.getColY().equals(point2.getColY()))){

            isEqual = true;

        }

        return isEqual;

    }

    //获取下一个点
    public Point genNextStep(Point point,String direction){

        Point pointNext = new Point();

        if (direction.equals("UP")){

            pointNext.setColX(point.getColX());
            pointNext.setColY(point.getColY() + 1.0);

        }
        else if (direction.equals("DOWN")){

            pointNext.setColX(point.getColX());
            pointNext.setColY(point.getColY() - 1.0);

        }
        else if (direction.equals("LEFT")){

            pointNext.setColX(point.getColX() - 1);
            pointNext.setColY(point.getColY());

        }

        else {

            pointNext.setColX(point.getColX() + 1);
            pointNext.setColY(point.getColY());

        }

        return pointNext;

    }


    public boolean isPointLegal(Point point, Integer numOfGaps){

        boolean isLegal = true;
        double x = point.getColX();
        double y = point.getColY();
        if (x > numOfGaps || x < 0){

            isLegal = false;

        }

        if ( y > numOfGaps || y < 0){

            isLegal = false;

        }

        return isLegal;

    }

    public boolean judgeEdgeEqual(BoxEdge boxEdge1,BoxEdge boxEdge2){

        boolean isEdgeEqual = false;
        Point boxEdge1Point1 = boxEdge1.getPoint1();
        Point boxEdge1Point2 = boxEdge1.getPoint2();
        Point boxEdge2Point1 = boxEdge2.getPoint1();
        Point boxEdge2Point2 = boxEdge2.getPoint2();

        if (((judgePointEqual(boxEdge1Point1,boxEdge2Point1))&&(judgePointEqual(boxEdge1Point2,boxEdge2Point2))) ||((judgePointEqual(boxEdge1Point1,boxEdge2Point2))&&(judgePointEqual(boxEdge1Point2,boxEdge2Point1)))){

            isEdgeEqual = true;

        }

        return isEdgeEqual;

    }

    public ArrayList<BoxEdge> findEqualBoxEdgeFromList(BoxEdge boxEdge,ArrayList<BoxEdge> boxEdgeArrayList){
        ArrayList<BoxEdge> equalBoxEdgeArrayList = new ArrayList<>();
        for (int i = 0 ; i < boxEdgeArrayList.size();i++){
            BoxEdge boxEdge1 = boxEdgeArrayList.get(i);
            if (judgeEdgeEqual(boxEdge,boxEdge1)){
                equalBoxEdgeArrayList.add(boxEdge1);
            }
        }
        return equalBoxEdgeArrayList;
    }



}
